import pymysql
from app import app
from db import mysql
from flask import jsonify,request,json
from flask_httpauth import HTTPBasicAuth
from flask_httpauth import HTTPTokenAuth
import decimal
import pandas as pd
import numpy as np
import functools
import operator
import requests
import json 
from requests.structures import CaseInsensitiveDict
import os
from dotenv import load_dotenv
project_folder = os.getcwd()
load_dotenv(os.path.join(project_folder, '.env'))


class DecimalEncoder(json.JSONEncoder):
    def default(self, o):
        if isinstance(o, decimal.Decimal):
            return '`'+str(o)+'`' #` is special, will be removed later
        return super(DecimalEncoder, self).default(o)

auth = HTTPTokenAuth(scheme='Bearer')

tokens = {
    os.getenv("TOKEN"): os.getenv("USER_TOKEN"),
}

headers = {'Authorization': 'Bearer '+ os.getenv("TOKEN") }

def randomSelect(data,group ,size=1, replace=False):
    index=[]
    fn = lambda obj: obj.loc[np.random.choice(obj.index, 1 , replace),:]
    while data.empty != True:
        randomListByUser=data.groupby(group, as_index=False).apply(fn)
        index.append( [ item for item in randomListByUser.index.get_level_values("id") ] )
        data=data.drop(randomListByUser.index.get_level_values("id"), axis=0)
    return functools.reduce(operator.iconcat, index, []) 

@auth.verify_token
def verify_token(token):
    if token in tokens:
        return tokens[token]

@app.route('/')
@auth.login_required
def index():
    return "Hello, {}!".format(auth.current_user())


@app.route('/articles')
@auth.login_required

def articles():
    conn = mysql.connect()

    cursor = conn.cursor(pymysql.cursors.DictCursor)
    cursor.execute("SELECT id,entreprise_id,category_id,user_id,created_at,localite,vues,secteur FROM articles")

    rows = cursor.fetchall()

    resp = jsonify(rows)
    resp.status_code = 200
    return resp

@app.route('/get_index')
@auth.login_required

def get_index():
    data = pd.read_json( json.dumps(requests.get(os.getenv("API_URL")+'/articles', headers=headers).json())).set_index("id")
    size = 1   # sample size
    replace = False  # with replacement
    return json.dumps( randomSelect(data, request.args.get('group'), size, replace))

if __name__ == "__main__":
    app.run(debug=True,host='0.0.0.0')

	



